#include <avr/io.h>

#include <util/delay_basic.h>
#define F_CPU 8000000UL  
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h> 
#include <avr/wdt.h> 





//                         76543210
#define K1_1     PORTD |=0b01000000
#define K2_1     PORTD |=0b00010000
#define K3_1     PORTD |=0b00001000
#define K4_1     PORTD |=0b00100000
#define K1_0     PORTD &=0b10111111
#define K2_0     PORTD &=0b11101111
#define K3_0     PORTD &=0b11110111
#define K4_0     PORTD &=0b11011111

#define max_ign 60000




unsigned int sek_100;
unsigned char min;
unsigned char hour;
unsigned char znakogenerator[]={235,136,179,186,216,122,123,168,251,250,99,16,67,87};
unsigned char data[5];
unsigned char data_default[]={0,0x70,0};
unsigned char flash_point;
unsigned char flash_counter;
unsigned char led_buffer[4];
unsigned char digit_online;
unsigned char mode;
unsigned char flag_buttion;
unsigned char flash_counter_digit;
unsigned char flash_digit;
unsigned int counter_press_buttion;
unsigned char flag_not_press;
unsigned int counter_not_press_buttion;
unsigned char corr_coef;
unsigned int corr_sec_100;
unsigned char flag_hour;
unsigned char light_min;
unsigned char flag_write;
unsigned int counter_ignition;


enum {mode_clock,mode_hour,mode_min,mode_corr,mode_min_light};


//



ISR (INT0_vect )
{
	if(counter_ignition>=max_ign)counter_ignition=36000;
	counter_press_buttion=0;
	counter_not_press_buttion=0;

}

//

// Timer 0 overflow interrupt service routine
ISR (TIMER0_OVF_vect)
{
// Reinitialize Timer 0 value
TCNT0=0x63;
K1_0;K2_0;K3_0;K4_0;
if(flash_digit==1)
			{
			switch (mode)
				{
				case mode_hour:
					led_buffer[0]=0;
					led_buffer[1]=0;
					
				break;
		
				case mode_min:case mode_min_light:
					led_buffer[2]=0;
					led_buffer[3]=0;
					
				break;
				
				case mode_corr:
					led_buffer[1]=0;
					led_buffer[2]=0;
					led_buffer[3]=0;
					
				break;
				
				}
		
			}
PORTB=led_buffer[digit_online];

if((PIND&0b00000010)==0)counter_ignition++;
else counter_ignition=0;
if(counter_ignition>=max_ign)counter_ignition=max_ign;

if((counter_ignition<max_ign)||(mode!=mode_clock))// <5 min no IGNITION*******************
	{
	switch (digit_online)
		{
		case 0:K1_1;
		break;
	
		case 1:K2_1;
		break;
	
		case 2:K3_1;
		break;
	
		case 3:K4_1;
		break;
		}
	}

digit_online++;
if(digit_online==4)digit_online=0;

}

// Timer 0 output compare A interrupt service routine
ISR (TIMER0_COMPA_vect)
{
K1_0;K2_0;K3_0;K4_0;

}


// Timer 1 overflow interrupt service routine
ISR (TIMER1_COMPA_vect )
{
// Reinitialize Timer 1 value
TCNT1H=0x00;
TCNT1L=0x00;
sek_100++;
if(sek_100==12000)
	{
	min++;
	sek_100=0;
	}
if(min==60)
	{
	hour++;
	min=0;
	flag_hour=1;
	}
if(hour==24)
	{
	hour=0;
	}

// corr*************************
if((flag_hour==1)&&(sek_100==1000))
	{
	flag_hour=0;
	if(corr_coef<100)sek_100=sek_100-corr_sec_100;
	else sek_100=sek_100+corr_sec_100;
	}



//******************************



flash_counter++;
if(flash_counter==100)
	{
	flash_counter=0;
	if(flash_point==0)
		{
		flash_point=1;
		
		}
	else 
		{
		flash_point=0;
		
		}
	}

flash_counter_digit++;
if(mode==mode_clock){flash_counter_digit=0;flash_digit=0;}
if(flash_counter_digit==10)
	{
	flash_counter_digit=0;
	if(flash_digit==0)
		{
		flash_digit=1;
		
		}
	else 
		{
		flash_digit=0;
		
		}
	}
if((PIND&0b00000100)==0)
	{
	counter_press_buttion++;
	counter_not_press_buttion=0;
	}

counter_not_press_buttion++;
	
if(counter_not_press_buttion==2000)
	{
	switch (mode)
			{
			case mode_min:
				mode=mode_hour;
				
			break;
		
			case mode_hour:
				mode=mode_corr;
				
			break;
			
			case mode_corr:
				mode=mode_min_light;
			
			break;
			
			case mode_min_light:
				mode=mode_clock;
				flag_write=1;
				counter_press_buttion=0;
			break;
			
			case mode_clock:
				
			break;
			}
	counter_not_press_buttion=0;
	}

}

//








// hour & min       

void decimal_digit (void) 
	{
	
	unsigned char b,c,d;
	
		
			
	b=hour;					
	c=b/10;
	if(c==0)led_buffer[0]=0;
	else led_buffer[0]=znakogenerator[c];
	d=c*10;
	b=b-d;
	led_buffer[1]=znakogenerator[b];
	
	if(flash_point==0)
		{
		
		led_buffer[1] |=0b00000100;
		}
	else 
		{
		
		led_buffer[1] &=0b11111011;
		}
		
	b=min;					
	c=b/10;
	led_buffer[2]=znakogenerator[c];
	d=c*10;
	b=b-d;
	led_buffer[3]=znakogenerator[b];
	
	}
	

	
	
//*********************************************************


//


int main(void)
{

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In 
// State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port D initialization
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=In Func0=In 
// State6=0 State5=0 State4=0 State3=0 State2=P State1=T State0=T 
PORTD=0x04;
DDRD=0x78;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x04;
TCNT0=0x63;
OCR0A=0x70;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x02;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x13;
OCR1AL=0x88;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x40;
MCUCR=0x02;
EIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x43;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
wdt_enable  (WDTO_120MS); 
mode=mode_clock;
eeprom_read_block(data,0,3);
if(data[2]==255)
	{
	eeprom_write_block(data_default,0,3);
	eeprom_read_block(data,0,3);
	}



sei();
unsigned char b,c,d;

while (1)
    {
	if((hour>23)||(min>59)||(sek_100>12000))
	{
	_delay_ms(500);
	}
	wdt_reset();
	corr_coef=data[0];
	corr_sec_100=corr_coef*8+corr_coef/3;
	
	light_min=data[1];

	if(flag_write==1)
		{
		eeprom_write_block(data,0,3);
		flag_write=0;
		}
	switch (mode)
		{
		case mode_hour:case mode_min:case mode_clock:
		decimal_digit();
		break;
		
		case mode_corr:
		led_buffer[0]=znakogenerator[10];
		if(corr_coef<100)led_buffer[1]=znakogenerator[11];
		else led_buffer[1]=0;
		b=data[0];
		if(data[0]>=100)b=b-100;
		c=b/10;
		led_buffer[2]=znakogenerator[c];
		d=c*10;
		b=b-d;
		led_buffer[3]=znakogenerator[b];
		break;
		
		case mode_min_light:
		led_buffer[0]=znakogenerator[12];
		led_buffer[1]=znakogenerator[13];
		b=light_min-100;
		c=b/10;
		led_buffer[2]=znakogenerator[c];
		d=c*10;
		b=b-d;
		led_buffer[3]=znakogenerator[b];
		break;
		
		
		
		
		
		
		}
	if(((PIND&0b00000001)==1)||(mode==mode_min_light))OCR0A=light_min;
	else OCR0A=0;

	
	
	if((counter_press_buttion>400)&&(mode==mode_clock))mode=mode_min;
	
	if((counter_press_buttion>=20)&&(counter_press_buttion<200)&&(mode!=mode_clock))
		{
		switch (mode)
			{
			case mode_hour:
				hour++;
			break;
		
			case mode_min:
				min++;
				sek_100=0;
			break;
			
			case mode_corr:
				data[0]++;
				if(data[0]==200)data[0]=0;
			break;
			
			case mode_min_light:
				data[1]++;
				if(data[1]==200)data[1]=100;
			break;
			
			}
		_delay_ms(50);
		counter_press_buttion=0;
		}
	

	}
}